%define	name	gentoo
%define	version	0.11.7
%define	release	1
%define	serial	2

Summary:	gentoo is a Gtk+ file manager for Linux.
Name:		%{name}
Version:	%{version}
Release:	%{release}
Serial:		%{serial}
Copyright:	GPL
Group:		X11/Utilities
URL:		http://www.obsession.se/gentoo
Vendor:		Emil Brink <emil@obsession.se>
Source:		ftp://ftp.obsession.se/gentoo/%{name}-%{version}.tar.gz
Patch:		%{name}-makefile.patch
Distribution:	Freshmeat RPMs
Packager:	Ryan Weaver <ryanw@infohwy.com>
Requires:	gtk+ >= 1.2.3
BuildRoot:	/tmp/%{name}-%{version}

%description
gentoo is a file manager for Linux written from scratch in pure C. It
uses the GTK+ toolkit for all of its interface needs. gentoo provides
100%% GUI configurability; no need to edit config files by hand and re-
start the program. gentoo supports identifying the type of various
files (using extension, regular expressions, and/or the 'file' command),
and can display files of different types with different colors and icons.
	gentoo borrows some of its look and feel from the classic Amiga
file manager "Directory OPUS"(TM) (written by Jonathan Potter).

%prep
%setup -q
%patch -p1

%build
make

%install
if [ -e $RPM_BUILD_ROOT ]; then rm -rf $RPM_BUILD_ROOT; fi

install -d $RPM_BUILD_ROOT/usr/bin
install -d $RPM_BUILD_ROOT/usr/lib/gentoo/icons
install -d $RPM_BUILD_ROOT/usr/man/man1

install -s -m 755 gentoo	$RPM_BUILD_ROOT/usr/bin
install -m 644 gentoorc-example $RPM_BUILD_ROOT/usr/lib/gentoo
install -m 644 gentoorc-example $RPM_BUILD_ROOT/usr/lib/gentoo/gentoorc
install -m 644 icons/*		$RPM_BUILD_ROOT/usr/lib/gentoo/icons
install -m 644 docs/gentoo.1x	$RPM_BUILD_ROOT/usr/man/man1

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc docs BUGS COPYING FIXES-0.11 FIXES-0.9 INSTALL README
%doc README.gtkrc gentoogtkrc-example gentoorc-example
/usr/bin/gentoo
/usr/lib/gentoo
/usr/man/man1/gentoo.1x

%changelog
* Tue Jun  1 1999 Ryan Weaver <ryanw@infohwy.com>
  [gentoo-0.11.7-1]
- Fixed bug in style handling for active pane indication. Reported
  by widget and icon author, J. Hanson (<johan@tiq.com>).
- Fixed a bug in dialog for selecting built-in command (seen in
  the Commands config), also reported by Johan.
- Fixed an infinite recursion bug in the sizeutil module.
- Fixed handling of directory sizes in Information command. Should
  now happily handle directories with more than 2 GB of contents.
- Totally rewrote the styles and cfg_styles modules, that deal
  with the file styles; roughly 2,000 lines of new code. The new
  style system is a *lot* more flexible than the old was, but pays
  with a bit of speed. Info in "docs/scratch/filestyles.txt".
- Fixed a bug which had the GetSize command accumulating sizes
  on each call, if its unselection flag was off.
- Improved handling of double click on already selected row.
- The Rename command no longer rescans the *destination* pane when
  it's finished. That's good, since it was a waste of time. :)
- Removed the ViewTextHex and ViewTextOrHex commands; you now get
  the same functionality by using "ViewText mode=hex" and
  "ViewText mode=auto", respectively. You can force text viewing
  by using "ViewText mode=text", but that is the default.
- Trying to execute a non-existant external command should now be
  much less prone to crash gentoo.
- Fixed a weakness in the mount support which made it fail on
  root mountpoints. Weird.
- Implemented (more or less) transparent support for symbolic
  links. The support is complemented by four new builtin commands:
  SymLink, SymLinkAs, SymLinkClone and SymLinkEdit. Read all (or
  at least some) about it in "docs/scratch/symlinks.txt".
- Resorting no longer messes up the selection. Oops.

* Tue May 18 1999 Ryan Weaver <ryanw@infohwy.com>
  [gentoo-0.11.6-1]
- Fixed a long-standing bug in the icon selection dialog, which
  prevented it from displaying any icons. This bug never bit me,
  but always J. Minnberg, and he kept bugging me about it, so to
  speak. It had been there since 0.9.19. Fascinating.
- The GetSize command now has a flag (configurable through the
  Command Options page) that controls whether or not it deselects
  the directories after traversing.
- Rewrote some of the dirpane internals, especielly stuff having
  to do with sorting, and redisplaying a pane's contents. It's
  now a bit better structured, and I think a tad faster, too!
- Did some minor user interface improvements in the configuration
  window. All suggested by J. Hanson <johan@tiq.com>.
- The ChMod command now rescans the source pane, thus making any
  changes visible in gentoo, as well. Oops.
- The Delete command now shows progress, thus giving you at least
  a chance to cancel it. It also now knows how to get rid of FIFOs,
  sockets, and special device nodes in general.
- Implemented support for J. Hanson's *glorious* new button widget,
  which allows the use of two commands: depending on which mouse
  button you click (first or second (=middle)), the button will
  activate either the primary or secondary command. The widget also
  supports custom coloring on both back- and foreground on each of
  the two "faces". All in all, it's great! Thanks, Johan.
- Added a primitive XML node type for RGB colors, making their
  loading and saving in the config file both leaner and simpler.
- Built-in commands can now take arguments to modify their behaviour.
  Flexibility++! Read about it in "docs/scratch/command_args.txt".
- The SelectRE command now makes full use of command arguments, so
  you can have commands such as "SelectRE glob=true re=*.jpg". Also
  added two new options in the process.
- Removed the QuitNow command, since the very same effect can now
  be achieved by using "Quit dialog=false". Command args rule.
- DirEnter now takes an argument specifying the wanted path. This
  makes it possible to create normal buttons acting as shortcuts...
- Wrote a simple general color editing dialog, for buttons & styles.
- Fixed a little bug that would execute a command twice if it was
  both set to repeat and then invoked through a pane double-click.
- Added a couple of missing {}-codes to the pick dialog in the
  Commands config page ({fu}, {Fu}, {fd} and {Fd}). Please note that
  you can include any of "udp" with either of {f} and {F}. The total
  number of valid f-codes is therefore 2*8 = 16. Not all are included
  in the dialog. :)
- gentoo now computes a pane's total available & selected byte counts
  using explicit 64-bit arithmetic. Since this is not available in
  ANSI C, the code is slightly less ANSI-pure because of this. The
  upside is that having an 8-GB partition with 5.5 GB free now should
  show the correct numbers. Note that individual file sizes are still
  typically handled as 32-bit integers (unless you're on an Alpha,
  I think). Only *total* sizes are affected by this change. Also note
  that the change does not affect the GetSize command. The Information
  command might do a better job (but it is untested). Later...
- The command dialog window (shown by the Run command, and whenever
  you need to specify a command name in config) now does true Tab-
  activated command name completion.
- Fixed a weird buglet in the shortcuts config, having to do with
  changing the order of the shortcuts.
- Fixed a couple of confused memory allocation calls in buttons
  code. It hit when you tried to resize a row. Oops. :(
- Thanks to input provided by Alexander Moss Tahk (<tahk@mit.edu>),
  gentoo should now compile and run on OpenBSD. Extending this to
  other BSD's should be trivial (I hope).
- gentoo now supports a rudimentary form of keyboard navigation,
  thus hopefully forcing most people who mail me about gentoo to
  wish for something else. :) For more information about it, check
  out "docs/scratch/focusing.txt". The supplied example config is
  set up to use it (try up/down cursor keys, shifted up/down cursor
  keys, space, home, end, insert, and ctrl-L). Note that the sample
  config hence no longer has ActivateOther on space (but try Tab!).
- In a fit of extreme ambition, I rewrote almost all of the code
  for configuring dirpane contents. It's a *lot* cleaner now.
- While I was at it, I made the colors used in dirpanes in general
  (active pane and focusing) configurable, as well.
- You can now configure on what side of the pane the scrollbar
  should go.
- Fixed a little problem that caused a GTK+ warning when reentering
  the config if you exit it on the "Commands Options" page visible.
- Changing the width of a pane column by dragging it directly in
  the pane now counts as a config change (=> dialog on quit).

* Fri Apr 23 1999 Ryan Weaver <ryanw@infohwy.com>
  [gentoo-0.11.5-1]
- Dialogs should now open closer to the mouse cursor (if supported
  by your window manager). Suggested by "Peter" <zed@linuxpower.org>.
- Command input dialogs ({I...}) were broken, and probably have been
  since 0.11.1. Reported by J. Minnberg <jonas@obsession.se>. Does
  nobody else *use* gentoo? :( Ah well.
- Any processes spawned by gentoo would be killed twice on quit; I
  really think once should be enough.
- When you re-run a asynchronous, kill-previous command, gentoo is
  now more patient with waiting for the previous instance to die.
- Did loads of code-cleaning (glib-ification, const-ifying, etc).
- Removed the (very obsolete) "docs/porting/" directory.
- The size shown by GetSize is now actually considered and added into
  the sum shown in the status bar when GetSize:d dirs are selected.
- GetSize now also computes the number of _blocks_ in the directory.
- Added a ClearSize command that makes gentoo forget a directory's
  "recursive" size and reset it to the actual filesystem size.
- Resorting a pane no longer confuses the selection information.
- Removed an annoying GTK+ warning from the progress reporting code.
- Added support for TARGA & TIFF images to the example config. :)
- If you change the "enter dir" flag in the MkDir window, this will
  be registered as a config change (=> confirm/save dialog on quit).
- Removed the pointless "OK" message which use to indicate success-
  ful command execution. Now the status text appears instead, thus
  giving useful information faster. No news is good news.
- The text viewing window can now be made smaller. :)
- If, when you click "Add" in the styles config page, the currently
  selected style is collapsed (its children are hidden), it is
  now expanded for you.
- The DirToOther and DirFromOther commands now clear the selection
  from the pane before replacing the pane's contents. This prevents
  a rather interesting selection-merging phenomenon from occuring.
- The DirEnter command now makes sure the row being entered is
  unselected first. Not all directories are double-clicked into...
- Fixed a buglet (fix is 12 bytes) that prevented the "..." button
  in the command config from showing available builtin commands.
- Added a short paragraph about sorting to the man page, taking
  extra care to plug Style (icon) sorting, since it's so cool. :)
- Discovered a weird lock-up with the command output grabbing (which
  I'll blame on GDK for now), added a quick-n-dirty work-around which
  seemed to fix it. The problem occured when e.g. listing long tar
  archives (read: Linux kernel), it deadlocked at EOF. Real odd.
